import type SymbolArtInterface from './interfaces/SymbolArtInterface';
/** SymbolArt Class */
export default class SymbolArt {
    /** Get Version */
    static version: any;
    /** Get Build Date */
    static build: any;
    /** Sar file Magic number */
    private static readonly FILE_MAGIC_NUMBER;
    /** Decrypt Key */
    private static readonly BLOWFISH_KEY;
    /** Compressed Flag */
    private static readonly FLAG_COMPRESSED;
    /** Uncompressed Flag */
    private static readonly FLAG_NOT_COMPRESSED;
    /** Cryptor */
    private readonly browfish;
    /** Decrypted Data */
    private decrypted;
    /**
     * Constructor
     */
    constructor();
    /**
     * Get SymbolArt Data
     */
    get data(): ArrayBuffer;
    /**
     * Set SymbolArt Data
     *
     * @param buffer - Synbolart(*.sar) File array buffer.
     */
    set data(buffer: ArrayBuffer);
    /** Get JSON Parsed SymbolArt Data */
    get json(): SymbolArtInterface;
    /**
     * Set Symbolart Data from JSON
     *
     * @param data - Symbol Art JSON data
     */
    set json(data: SymbolArtInterface);
    /**
     * Creates a new Uint8Array based on two different ArrayBuffers
     *
     * @param  buffer1 - The first buffer.
     * @param  buffer2 - The second buffer.
     */
    private appendBuffer;
}
